/**
 * Formularanwendung für das Robo Interface mit I/O Extension
 * FT-Plotter mit 2 Schrittmotoren (an M1/M2 sowie M3/M4) sowie Stift an O9
 * 
 * Treiber: FtLib.dll (8.6.2011) umFish40.dll (26.8.17 v5.3.0.1)
 *          schnelle Tastenabfrage: getKeyState 
 *          schnelle Schrittmotor-Befehle: stepperZ stepperV
 *    javafish40.dll (25.7.17) Wrapper-Datei
 *    ftcomputing.robo.jar (11.8.17) -> java-Bibliothek mit FishFace
 * 
 * Verbindung über USB (Datenübertragung über Data Link ist zu langsam)
 * 
 * Anzeige von Sensorwerten im JFrame (aus javax.swing)
 * Direkte Steuerung des Stiftes über das Ziffernfeld
 * 
 * Ergänzungen:
 *   In ein JTextField können die Koordinaten von Punkten eingegeben werden
 *   und zwar in der Form x1 y1 x2 y2 x3 y3 ..
 *   Mit lineto wird dann eine "Streckenzug" gezeichnet, der mit (x1|y1) beginnt.
 *   
 *   Kreisfunktion, Spirale (Testversion: Start über k bzw. s) 
 *   Skalierbare Ziffern 0..9 (Testweise über pqwertzuio)
 * 
 * Achtung: 
 *   Sollen Stepper-Befehle über Buttons und actionPerformed aufgerufen werden,
 *   dann sollte die schnelle Tastaturabfrage in der do..while-Schleife über den Flag
 *   homeaktiv verhindert werden.
 *    
 * Jawtusch 31.8.2017
 */
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.MaskFormatter;
import java.util.ArrayList;
import java.lang.*;
import ftcomputing.robo.*; // Bibliothek mit Klasse FishFace
import ch.aplu.turtle.*;
 
class List{
    double x;
    double y;
}
class Punkt{
    String x;
    String y;
}


public class gFaceRB  {
    
private Turtle t;    

ArrayList<Punkt> punkte = new ArrayList<>();
private JTextField pxtf = new JTextField(3); // zur Eingabe einer Liste von Punkten

private FishFace rb = new FishFace(); // rb liefert alle Methoden für das Robo-Interface 

private JLabel Com = new JLabel();
private JLabel lblStatus = new JLabel("Robo Interface -> FT-Plotter",JLabel.CENTER);
private JLabel lblPosition = new JLabel(" ", JLabel.CENTER);
private JLabel lblSpur = new JLabel(" ", JLabel.CENTER);
private JLabel lblDist = new JLabel(" ", JLabel.CENTER);
private JLabel lblTaster = new JLabel(" ", JLabel.CENTER);
private JLabel lblgps = new JLabel(" ", JLabel.CENTER);
private JLabel lblHinweis = new JLabel(" ", JLabel.CENTER);
private JLabel lblHinweis1 = new JLabel(" ", JLabel.CENTER);
private JLabel lblHinweis2 = new JLabel(" ", JLabel.CENTER);
private JLabel ziel = new JLabel("Nächster Zielpunkt?", JLabel.CENTER);
private JButton butUrsprung = new JButton("Streckenzug");

int stepperdelay = 11; // ca. 11ms Verzögerung 
int px = 0, py = 0;
boolean homeaktiv = false;
String[] koordinaten = {"0", "0"};
List[] ziffer = new List[7];
double sg = 9; //Schriftgröße

    /**
     * Constructor for objects of class gFaceRB
     */
public gFaceRB()
    { for (int k = 0; k < 7; k++) {
        ziffer[k] = new List();}
        t = new Turtle(new TurtleFrame("Turtle",720, 420));
        t.ht(); t.penUp();
        JFrame meinJFrame = new JFrame();
       // meinJFrame.setLayout(null) ;
      meinJFrame.setLayout(new GridLayout(0, 1, 8, 18));
      meinJFrame.setSize(280, 500); 

      meinJFrame.setTitle("FT-Plotter"); 
       
       meinJFrame.add(butUrsprung);
       pxtf.setBounds(50,50,300,50);
       pxtf.addActionListener(new ActionListener() {
       public void actionPerformed(ActionEvent e) {
           String eingabe = pxtf.getText();
           koordinaten = eingabe.split(" "); 
           punkte.clear();
           for (int n = 0; n < (koordinaten.length) ; n = n + 2) {
               Punkt punkt = new Punkt();
               punkt.x = koordinaten[n] ; punkt.y = koordinaten[n + 1];
            punkte.add(punkt); }
           String pliste = "";
           String anzeige = "Streckenzug ab: " + punkte.get(0).x+" | "+ punkte.get(0).y;
           for(Punkt item: punkte){
             pliste = pliste + " | " + item.x + " " + item.y ;}
           butUrsprung.setText(anzeige);
           ziel.setText("Zielpunkte sind: " + pliste);
           butUrsprung.requestFocus();
          }});
         
       butUrsprung.addActionListener(new ActionListener() {
       public void actionPerformed(ActionEvent e) {
         boolean first = true;
         for(Punkt item: punkte){
             if (first) {
              moveto(Integer.parseInt(item.x),Integer.parseInt(item.y)); first = false;}
             else { pd();
                 lineto(Integer.parseInt(item.x),Integer.parseInt(item.y));}
            }
         pu();
          }});
      
       meinJFrame.add(Com);
       meinJFrame.add(lblStatus);
      
       meinJFrame.add(lblPosition);
       meinJFrame.add(lblDist);
       meinJFrame.add(lblTaster);
       meinJFrame.add(lblSpur);
       meinJFrame.add(lblgps);
       meinJFrame.add(lblHinweis);
       meinJFrame.add(lblHinweis1);
       meinJFrame.add(lblHinweis2);
       meinJFrame.add(ziel);
       meinJFrame.add(butUrsprung);
       meinJFrame.add(pxtf);
       meinJFrame.setVisible(true);  
 }

public static void main() { //String[] args
gFaceRB gf = new gFaceRB();
gf.Action();
}

private void Action() {
 
butUrsprung.requestFocus();

try {
Com.setForeground(Color.BLUE);
rb.openInterface(0, 0);
//Verbindung über RF DATA LINK:  rb.openInterfaceRFdis(1, 1) 
//Verbindung über ROBO Connect Box:  rb.openInterface(200, 1) 
Com.setText("USB verbunden  . . .  ftcomputing: " + rb.Version());
lblHinweis.setText("Plotten: '1 2 3 4  6 7 8 9' ");
lblHinweis1.setText("Stiftab: ','  Stifthoch: '0' ");
lblHinweis2.setText("Home: '5'  Ende: ESC");
//int Spurl = 0, Spurr = 0; rb.clearCounters(); 

do {
// optionale Anzeige von Sensorwerten:
/* lblStatus.setText("Counter : " + rb.getCounter(2) + 
  " " + rb.getCounter(4));
  lblLicht.setText("Photowiderstand AX / AY : " +
  rb.getAnalog(1) + " / " + rb.getAnalog(2));
  lblDist.setText("Distance D1: " +
  rb.getDistance(1));
  if (rb.getInput(5)) Spurl = 0 ; else Spurl = 1;   // Spurensensor für Skanner-Betrieb
  if (rb.getInput(6)) Spurr = 0 ; else Spurr = 1;
  lblSpur.setText("Spur  I5 / I6 : " + Spurl + " " + Spurr);
*/
  lblPosition.setText("Stift-Position: ( " + px + " / " + py + " )");
  lblTaster.setText("Taster I7 / I8 : " + rb.getInput(7) + " / " + rb.getInput(8));
  if (!homeaktiv) // Keine zeitraubende Tastaturabfrage, wenn home über actionPerformed aufgerufen wurde.
  {
  if(rb.getKeyState(102))           //if-Kaskade zur Steuerung des Plotter-Stiftes
             {xv();}
  if(rb.getKeyState(110))
             {pd(); }
  if(rb.getKeyState(96))
             {pu();}     
  if(rb.getKeyState(102))           //if-Kaskade zur Steuerung des Plotter-Stiftes
             {xv();}
   else if(rb.getKeyState(100))
            { xz();}
    else if(rb.getKeyState(98))
            {yz();}
     else if(rb.getKeyState(104))
           {yv();}
      else if (rb.getKeyState(97))
             {xz(); yz();}
       else if(rb.getKeyState(103))
            { xz(); yv();}
        else if(rb.getKeyState(105))
            {xv(); yv();}
         else if(rb.getKeyState(99))
            {xv(); yz();}
          else if(rb.getKeyState(101))
            { while (rb.getInput(7) && !rb.finish()) { 
              xz(); lblPosition.setText("Stift-Position: ( " + px + " / " + py + " )");}
              xaus(); px = 0;
              while (rb.getInput(8) && !rb.finish()) {
              yz(); lblPosition.setText("Stift-Position: ( " + px + " / " + py + " )");}
              yaus(); py = 0;  
              t.setPos(-360,-210); t.ht();
            }
           else if(rb.getKeyState(75))
              {kreis(400,200, 100);
              } 
            else if(rb.getKeyState(83))
              {spirale(250,200, 20);
              } 
               else if(rb.getKeyState(80))
              {Null(sg);
              }
              else if(rb.getKeyState(77))
              {Minus(sg);
              }
               else if(rb.getKeyState(81))
              {Eins(sg);
              }
              else if(rb.getKeyState(68))
              {Komma(sg);
              }
               else if(rb.getKeyState(87))
              {Zwei(sg);
              }
               else if(rb.getKeyState(69))
              {Drei(sg);
              }
               else if(rb.getKeyState(82))
              {Vier(sg);
              }
               else if(rb.getKeyState(84))
              {Fuenf(sg);
              }
                else if(rb.getKeyState(90))
              {Sechs(sg);
              }
               else if(rb.getKeyState(85))
              {Sieben(sg);
              }
               else if(rb.getKeyState(73))
              {Acht(sg);
              }
              else if(rb.getKeyState(79))
              {Neun(sg);
              }
               else if(rb.getKeyState(89))
              {Zahl(String.valueOf(-3.14));
              }
  }
 } while (!rb.finish());  
}
catch (FishFaceException eft) {
lblStatus.setText(eft.toString());}
finally {
  ziel.setForeground(Color.RED);
  ziel.setText("Verbindung wird abgebrochen!");
   try { Thread.sleep(2000);
         } catch (Exception e) {
            System.out.println(e);
         }
  rb.closeInterface();
System.exit(0);
}
}
private void xaus() {
    rb.setMotor(1,0); rb.setMotor(2,0);}
private void yaus() {
    rb.setMotor(3,0); rb.setMotor(4,0);}
private void xv() {
    rb.stepperV(1,2,stepperdelay); t.setH(90); t.fd(1);
    px++;}
private void xz() {
    if (rb.getInput(7)) {
    rb.stepperZ(1,2,stepperdelay);
    t.setH(-90); t.fd(1);
    px--;} else {xaus(); px = 0;}}    
private void yv() {
    rb.stepperV(3,4,stepperdelay);
    t.setH(0); t.fd(1);
    py++;}
private void yz() {
    if (rb.getInput(8)) {
    rb.stepperZ(3,4,stepperdelay);
    t.setH(180); t.fd(1);
    py--;} else {yaus();py = 0;}}    
private void pd() {rb.setLamp(9,1); t.penDown(); rb.pause(60);}   
private void pu() {rb.setLamp(9,0); t.penUp(); } 
    
private void home() {
   homeaktiv = true; t.ht();
   while (rb.getInput(7) && !rb.finish()) { xz();}
       xaus(); px = 0;
   while (rb.getInput(8) && !rb.finish()) {yz();}
       yaus(); py = 0;
   homeaktiv = false;    
  } 
private List mul (int k, List u) {
    List op = new List();
    op.x = k*u.x; op.y=k*u.y;
    return op;
}
private int zahl (List p, List z){
    double dx = z.x - p.x;
    double dy = z.y - p.y;
    double r = Math.abs(dx) + Math.abs(dy);
    if (r == 0) r = 1;
    return (int)r;
}
private List richtung (List p, List z){
    int n = zahl (p,z);
    List op = new List();
    op.x = (z.x - p.x) / n;
    op.y = (z.y - p.y) / n;
    return op;
}
private void lineto (int x, int y){
    homeaktiv = true;
    int vx, vy;
    List u = new List();
    List v = new List();
    List z = new List(); z.x = x; z.y = y;
    List aktp = new List();
    aktp.x = px; aktp.y = py;
    u = richtung (aktp, z);
    int vxalt = 0; int vyalt = 0;
    for (int n=1; n<= zahl(aktp,z); n++) {
     v = mul(n,u);
     vx = (int)Math.round(v.x);vy = (int)Math.round(v.y);
     if (vxalt < vx) {xv(); vxalt++;}
     if (vxalt > vx) {xz(); vxalt--;}
     if (vyalt < vy) {yv(); vyalt++;}
     if (vyalt > vy) {yz(); vyalt--;}
    }
    xaus(); yaus();
    px = (int)z.x; py = (int)z.y;
    homeaktiv = false;
}
private void moveto (int x, int y){
    int dx  = x - px; int dy = y - py; int k;
    if (dx > 0) {for (k = 0; k < dx; k++) xv();}
    if (dx < 0) {for (k = 0; k < -dx; k++) xz();}
    if (dy > 0) {for (k = 0; k < dy; k++) yv();}
    if (dy < 0) {for (k = 0; k < -dy; k++) yz();}
    px = x; py = y; 
}
private void moveto (List p){
    moveto((int)p.x,(int)p.y);
}
private void kreis (int mx, int my, int r){
    double b;
    moveto(mx + r, my); pd();
    for (int n = 5; n <= 360; n = n + 5){
      b=Math.toRadians(n);
      lineto(mx + (int)Math.round(r * Math.cos(b)), my + (int)Math.round(r * Math.sin(b)));
    }
    pu();
}
private void spirale (int mx, int my, double r){
    double b;
    moveto(mx + (int)r, my); pd();
    for (int j=0; j < 7; j++) {
    for (int n = 5; n <= 360; n = n + 5){
      b=Math.toRadians(n);
      r = r + 0.14;
      lineto(mx + (int)Math.round(r * Math.cos(b)), my + (int)Math.round(r * Math.sin(b)));
    }}
    pu();
}
private void raster (int x, int y, double sg) { //berechnet 7 Punkte für 7-Segmentanzeige
    ziffer[0].x = x; ziffer[0].y = y;
    ziffer[1].x = x + sg; ziffer[1].y = y;
    ziffer[2].x = x + sg*0.1; ziffer[2].y = y + sg*1.05;
    ziffer[3].x = x + sg*1.1; ziffer[3].y = y + sg*1.05;
    ziffer[4].x = x + sg*0.2; ziffer[4].y = y + sg*2.1;
    ziffer[5].x = x + sg*1.2; ziffer[5].y = y + sg*2.1;
    ziffer[6].x = x - sg*0.5; ziffer[6].y = y - sg*0.8;
}
private void lineto(List p) {
    lineto((int)p.x,(int)p.y);
}
private void Null(double sg) {
    raster(px,py,sg);
    pd();
    lineto(ziffer[4]);
    lineto(ziffer[5]);lineto(ziffer[1]);
    lineto(ziffer[0]); rb.pause(40);
    pu(); moveto( px + (int)Math.round(1.5*sg), py); xaus(); yaus();
}

private void Komma(double sg) {
    int x = px; int y = py;
    moveto( x + (int)Math.round(0.2*sg), y);
    raster(px,py,sg);
    pd();
    lineto(ziffer[6]);rb.pause(40);
    pu(); moveto( x + (int)Math.round(0.7*sg), y);xaus(); yaus();
}
private void Minus(double sg) {
    int x = px; int y = py;
    raster(px,py,sg);  
    moveto(ziffer[2]); 
    pd(); 
    lineto(ziffer[3]);
    lineto(ziffer[2]); rb.pause(40);
    pu(); moveto( x + (int)Math.round(1.5*sg), y);xaus(); yaus();
}
private void Eins(double sg) {
    int x = px; int y = py;
    moveto( x + (int)Math.round(0.2*sg), y);
    raster(px,py,sg);
    pd();
    lineto(ziffer[2]);lineto(ziffer[4]); rb.pause(40);
    pu(); moveto( x + (int)Math.round(0.7*sg), y);xaus(); yaus();
}
private void Zwei(double sg) {
    int x = px; int y = py;
    raster(px,py,sg);  
    moveto(ziffer[4]); 
    pd(); 
    lineto(ziffer[5]);lineto(ziffer[3]);
    lineto(ziffer[2]);lineto(ziffer[0]);
    lineto(ziffer[1]); rb.pause(40);
    pu(); moveto( x + (int)Math.round(1.5*sg), y);xaus(); yaus();
}
private void Drei(double sg) {
    int x = px; int y = py;
    raster(px,py,sg);  
    moveto(ziffer[4]); 
    pd(); 
    lineto(ziffer[5]);lineto(ziffer[3]);
    lineto(ziffer[2]);lineto(ziffer[3]);
    lineto(ziffer[1]); lineto(ziffer[0]);rb.pause(40);
    pu(); moveto( x + (int)Math.round(1.5*sg), y);xaus(); yaus();
}
private void Vier(double sg) {
    int x = px; int y = py;
    raster(px,py,sg); 
    moveto(ziffer[4]); 
    pd(); 
    lineto(ziffer[2]);lineto(ziffer[3]);
    lineto(ziffer[5]);lineto(ziffer[1]);rb.pause(40);
    pu(); moveto( x + (int)Math.round(1.5*sg), y);xaus(); yaus();
}
private void Fuenf(double sg) {
    int x = px; int y = py;
    raster(px,py,sg);
    moveto(ziffer[5]); 
    pd(); 
    lineto(ziffer[4]);lineto(ziffer[2]);
    lineto(ziffer[3]);lineto(ziffer[1]);
    lineto(ziffer[0]);rb.pause(40);
    pu(); moveto( x + (int)Math.round(1.5*sg), y);xaus(); yaus();
}
private void Sechs(double sg) {
    int x = px; int y = py;
    raster(px,py,sg);
    moveto(ziffer[5]); pd(); 
    lineto(ziffer[4]);lineto(ziffer[0]);
    lineto(ziffer[1]);lineto(ziffer[3]);
    lineto(ziffer[2]);rb.pause(40);
    pu(); moveto( x + (int)Math.round(1.5*sg), y);xaus(); yaus();
}
private void Sieben(double sg) {
    int x = px; int y = py;
    raster(px,py,sg);
    moveto(ziffer[2]); pd(); 
    lineto(ziffer[4]);lineto(ziffer[5]);
    lineto(ziffer[1]);rb.pause(40);
    pu(); moveto( x + (int)Math.round(1.5*sg), y);xaus(); yaus();
}
private void Acht(double sg) {
    int x = px; int y = py;
    raster(px,py,sg);
    pd();
    lineto(ziffer[1]);lineto(ziffer[5]);
    lineto(ziffer[4]);lineto(ziffer[2]);
    lineto(ziffer[3]);lineto(ziffer[2]); lineto(ziffer[0]);
    rb.pause(40); pu(); 
    moveto( x + (int)Math.round(1.5*sg), y);xaus(); yaus();
}
private void Neun(double sg) {
    int x = px; int y = py;
    raster(px,py,sg);
    pd(); 
    lineto(ziffer[1]);lineto(ziffer[5]);
    lineto(ziffer[4]);lineto(ziffer[2]);
    lineto(ziffer[3]);rb.pause(40);
    pu(); moveto( x + (int)Math.round(1.5*sg), y);xaus(); yaus();
}
private void druckeInt(String is){
    int ascii;
   for (int j=0; j < is.length(); j++) {
      ascii = (int)is.charAt(j);
      switch (ascii) {
     case 49: Eins(sg); break;
     case 50: Zwei(sg); break;
     case 51: Drei(sg); break;
     case 52: Vier(sg); break;
     case 53: Fuenf(sg); break;
     case 54: Sechs(sg); break;
     case 55: Sieben(sg); break;
     case 56: Acht(sg); break;
     case 57: Neun(sg); break;
          default: break;
        }
    }  
}
private void Zahl(String zs) {
    if (zs.charAt(0) == '-') {Minus(sg); zs = zs.substring(1);}
    if (zs.indexOf('.') > 0) {
    int k = zs.indexOf('.');
    druckeInt(zs.substring(0, k));
    Komma(sg);
    druckeInt(zs.substring(k+1));
    } 
    else druckeInt(zs);
}

}
