
/**
 * Formularanwendung für den Robo Explorer mit I/O Extension
 * FT-Plotter mit 2 Schrittmotoren (an M1/M2 sowie M3/M4) sowie Stift an O9
 * 
 * Treiber: FtLib.dll (8.6.2011) umFish40.dll (26.7.17)
 *          schnelle Tastenabfrage: getKeyState 
 *          schnelle Schrittmotor-Befehle: stepperZ stepperV
 *    javafish40.dll (25.7.17) Wrapper-Datei
 *    ftcomputing.robo.jar (11.8.17) java-Bibliothek mit FishFace
 * 
 * Eingabe von link im JTextField: Data Link
 * Eingabe von box im JTextField: Connect Box
 * Eingabe von usb im JTextField: USB
 * 
 * Anzeige von Sensorwerten im JFrame (aus javax.swing)
 * Steuerung des Stiftes über das Ziffernfeld
 * 
 * Jawtusch 11.8.2017
 */
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import ftcomputing.robo.*;
public class gFaceRB
{
   JFrame frmMain ;
FishFace rb = new FishFace();
JLabel Com = new JLabel();

JLabel lblStatus = new JLabel("Robo Interface -> FT-Plotter", JLabel.CENTER);
private JLabel lblPosition = new JLabel(" ", JLabel.CENTER);
JLabel lblFarbe = new JLabel(" ", JLabel.CENTER);
JLabel lblSpur = new JLabel(" ", JLabel.CENTER);
JLabel lblDist = new JLabel(" ", JLabel.CENTER);
JLabel lblTaster = new JLabel(" ", JLabel.CENTER);
JLabel lblgps = new JLabel(" ", JLabel.CENTER);
JLabel lblHinweis = new JLabel(" ", JLabel.CENTER);
JLabel lblHinweis1 = new JLabel(" ", JLabel.CENTER);
JLabel lblHinweis2 = new JLabel(" ", JLabel.CENTER);
JButton butUrsprung = new JButton("setze Ursprung");


int stepperdelay = 11; // ca. 10ms Verzögerung 
int px = 0, py = 0;
    /**
     * Constructor for objects of class gFaceTX
     */
    public gFaceRB()
    {  frmMain = new JFrame();
       frmMain.setLayout(new GridLayout(0, 1, 12, 24));
       frmMain.setSize(300, 450); 

//frmMain.requestFocus();
    
butUrsprung.addActionListener(new ActionListener() {
       public void actionPerformed(ActionEvent e) {
       px = 0; py = 0; 
        }
     });
frmMain.setTitle("FT-Plotter");     
frmMain.add(Com);
frmMain.add(butUrsprung);
frmMain.add(lblStatus);
frmMain.add(lblPosition);
frmMain.add(lblDist);
frmMain.add(lblTaster);
frmMain.add(lblSpur);
frmMain.add(lblgps);
frmMain.add(lblHinweis);
frmMain.add(lblHinweis1);
frmMain.add(lblHinweis2);
frmMain.setVisible(true);
}     
public static void main(String[] args) {

gFaceRB gf = new gFaceRB();
gf.Action();
}

private void Action() {

butUrsprung.requestFocus();

try {
Com.setForeground(Color.BLUE);
rb.openInterface(0, 0);
//Verbindung über RF DATA LINK:  rb.openInterfaceRFdis(1, 1) 
//Verbindung über ROBO Connect Box:  rb.openInterface(200, 1) 
Com.setText("USB verbunden  . . .  ftcomputing: " + rb.Version());
lblHinweis.setText("Plotten: '1 2 3 4  6 7 8 9' ");
lblHinweis1.setText("Stiftab: ','  Stifthoch: '0' ");
lblHinweis2.setText("Home: '5'  Ende: ESC");
//int Spurl = 0, Spurr = 0; rb.clearCounters(); home();


int Spurl = 0, Spurr = 0;

do {
// optionale Anzeige von Sensorwerten:
/* lblStatus.setText("Counter : " + rb.getCounter(2) + 
  " " + rb.getCounter(4));
  lblLicht.setText("Photowiderstand AX / AY : " +
  rb.getAnalog(1) + " / " + rb.getAnalog(2));
  lblDist.setText("Distance D1: " +
  rb.getDistance(1));
  if (rb.getInput(5)) Spurl = 0 ; else Spurl = 1;        // Spurensensor für Scanner-Betrieb
  if (rb.getInput(6)) Spurr = 0 ; else Spurr = 1;
  lblSpur.setText("Spur  I5 / I6 : " + Spurl + " " + Spurr);
*/
 lblPosition.setText("Stift-Position: ( " + px + " / " + py + " )");
lblTaster.setText("Taster I7 / I8 : " + rb.getInput(7) + " / " + rb.getInput(8));

  if(rb.getKeyState(110))
             {rb.setLamp(9,1);}
  if(rb.getKeyState(96))
             {rb.setLamp(9,0);}     
  if(rb.getKeyState(102))           //if-Kaskade zur Steuerung des Plotter-Stiftes
             {xv();}
   else if(rb.getKeyState(100))
            { xz();}
    else if(rb.getKeyState(98))
            {yz();}
     else if(rb.getKeyState(104))
           {yv();}
      else if (rb.getKeyState(97))
             {xz(); yz();}
       else if(rb.getKeyState(103))
            { xz(); yv();}
        else if(rb.getKeyState(105))
            {xv(); yv();}
         else if(rb.getKeyState(99))
            {xv(); yz();}
          else if(rb.getKeyState(101))
            {home();}
          else { xaus(); yaus();}
 } while (!rb.finish());  
}
catch (FishFaceException eft) {
lblStatus.setText(eft.toString());}
finally {
rb.closeInterface();
lblHinweis.setText("Finito");
System.exit(0);
}
}

private void xaus() {
    rb.setMotor(1,0); rb.setMotor(2,0);}
private void yaus() {
    rb.setMotor(3,0); rb.setMotor(4,0);}
private void xv() {
    rb.stepperV(1,2,stepperdelay);
    px++;}
private void xz() {
    if (rb.getInput(7)) {rb.stepperZ(1,2,stepperdelay);
    px--;} else {xaus(); px = 0;}}    
private void yv() {
    rb.stepperV(3,4,stepperdelay);
    py++;}
private void yz() {
    if (rb.getInput(8)) {rb.stepperZ(3,4,stepperdelay);
    py--;} else {yaus();py = 0;}}      
    
private void home() {
   while (rb.getInput(7)) {
       xz(); lblPosition.setText("Stift-Position: ( " + px + " / " + py + " )");}
       xaus(); px = 0;
   while (rb.getInput(8)) {
       yz(); lblPosition.setText("Stift-Position: ( " + px + " / " + py + " )");}
       yaus(); py = 0;
  }
}

